/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * User
 */

public class User {
  @JsonProperty("about")
  private String about = null;

  @JsonProperty("active")
  private Boolean active = null;

  @JsonProperty("avatar")
  private String avatar = null;

  @JsonProperty("avatar_thumbnail")
  private String avatarThumbnail = null;

  @JsonProperty("first_name")
  private String firstName = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_name")
  private String lastName = null;

  @JsonProperty("metrics")
  private Object metrics = null;

  @JsonProperty("organizations")
  private List<OrganizationReference> organizations = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("roles")
  private List<String> roles = null;

  @JsonProperty("since")
  private LocalDateTime since = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("uri")
  private String uri = null;

  @JsonProperty("website")
  private String website = null;

  public User about(String about) {
    this.about = about;
    return this;
  }

   /**
   * The user self description
   * @return about
  **/
  @ApiModelProperty(value = "The user self description")
  public String getAbout() {
    return about;
  }

  public void setAbout(String about) {
    this.about = about;
  }

  public User active(Boolean active) {
    this.active = active;
    return this;
  }

   /**
   * Get active
   * @return active
  **/
  @ApiModelProperty(value = "")
  public Boolean isActive() {
    return active;
  }

  public void setActive(Boolean active) {
    this.active = active;
  }

  public User avatar(String avatar) {
    this.avatar = avatar;
    return this;
  }

   /**
   * The user avatar URL
   * @return avatar
  **/
  @ApiModelProperty(value = "The user avatar URL")
  public String getAvatar() {
    return avatar;
  }

  public void setAvatar(String avatar) {
    this.avatar = avatar;
  }

  public User avatarThumbnail(String avatarThumbnail) {
    this.avatarThumbnail = avatarThumbnail;
    return this;
  }

   /**
   * The user avatar thumbnail URL. This is the square (500x500) and cropped version.
   * @return avatarThumbnail
  **/
  @ApiModelProperty(value = "The user avatar thumbnail URL. This is the square (500x500) and cropped version.")
  public String getAvatarThumbnail() {
    return avatarThumbnail;
  }

  public void setAvatarThumbnail(String avatarThumbnail) {
    this.avatarThumbnail = avatarThumbnail;
  }

  public User firstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

   /**
   * The user first name
   * @return firstName
  **/
  @ApiModelProperty(required = true, value = "The user first name")
  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public User id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The user identifier
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The user identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public User lastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

   /**
   * The user last name
   * @return lastName
  **/
  @ApiModelProperty(required = true, value = "The user last name")
  public String getLastName() {
    return lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

   /**
   * The user metrics
   * @return metrics
  **/
  @ApiModelProperty(value = "The user metrics")
  public Object getMetrics() {
    return metrics;
  }

  public User organizations(List<OrganizationReference> organizations) {
    this.organizations = organizations;
    return this;
  }

  public User addOrganizationsItem(OrganizationReference organizationsItem) {
    if (this.organizations == null) {
      this.organizations = new ArrayList<OrganizationReference>();
    }
    this.organizations.add(organizationsItem);
    return this;
  }

   /**
   * The organization the user belongs to
   * @return organizations
  **/
  @ApiModelProperty(value = "The organization the user belongs to")
  public List<OrganizationReference> getOrganizations() {
    return organizations;
  }

  public void setOrganizations(List<OrganizationReference> organizations) {
    this.organizations = organizations;
  }

   /**
   * The user profile page URL
   * @return page
  **/
  @ApiModelProperty(value = "The user profile page URL")
  public String getPage() {
    return page;
  }

  public User roles(List<String> roles) {
    this.roles = roles;
    return this;
  }

  public User addRolesItem(String rolesItem) {
    if (this.roles == null) {
      this.roles = new ArrayList<String>();
    }
    this.roles.add(rolesItem);
    return this;
  }

   /**
   * Site wide user roles
   * @return roles
  **/
  @ApiModelProperty(value = "Site wide user roles")
  public List<String> getRoles() {
    return roles;
  }

  public void setRoles(List<String> roles) {
    this.roles = roles;
  }

  public User since(LocalDateTime since) {
    this.since = since;
    return this;
  }

   /**
   * The registeration date
   * @return since
  **/
  @ApiModelProperty(required = true, value = "The registeration date")
  public LocalDateTime getSince() {
    return since;
  }

  public void setSince(LocalDateTime since) {
    this.since = since;
  }

  public User slug(String slug) {
    this.slug = slug;
    return this;
  }

   /**
   * The user permalink string
   * @return slug
  **/
  @ApiModelProperty(required = true, value = "The user permalink string")
  public String getSlug() {
    return slug;
  }

  public void setSlug(String slug) {
    this.slug = slug;
  }

  public User uri(String uri) {
    this.uri = uri;
    return this;
  }

   /**
   * The user API URI
   * @return uri
  **/
  @ApiModelProperty(required = true, value = "The user API URI")
  public String getUri() {
    return uri;
  }

  public void setUri(String uri) {
    this.uri = uri;
  }

  public User website(String website) {
    this.website = website;
    return this;
  }

   /**
   * The user website
   * @return website
  **/
  @ApiModelProperty(value = "The user website")
  public String getWebsite() {
    return website;
  }

  public void setWebsite(String website) {
    this.website = website;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    User user = (User) o;
    return Objects.equals(this.about, user.about) &&
        Objects.equals(this.active, user.active) &&
        Objects.equals(this.avatar, user.avatar) &&
        Objects.equals(this.avatarThumbnail, user.avatarThumbnail) &&
        Objects.equals(this.firstName, user.firstName) &&
        Objects.equals(this.id, user.id) &&
        Objects.equals(this.lastName, user.lastName) &&
        Objects.equals(this.metrics, user.metrics) &&
        Objects.equals(this.organizations, user.organizations) &&
        Objects.equals(this.page, user.page) &&
        Objects.equals(this.roles, user.roles) &&
        Objects.equals(this.since, user.since) &&
        Objects.equals(this.slug, user.slug) &&
        Objects.equals(this.uri, user.uri) &&
        Objects.equals(this.website, user.website);
  }

  @Override
  public int hashCode() {
    return Objects.hash(about, active, avatar, avatarThumbnail, firstName, id, lastName, metrics, organizations, page, roles, since, slug, uri, website);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class User {\n");

    sb.append("    about: ").append(toIndentedString(about)).append("\n");
    sb.append("    active: ").append(toIndentedString(active)).append("\n");
    sb.append("    avatar: ").append(toIndentedString(avatar)).append("\n");
    sb.append("    avatarThumbnail: ").append(toIndentedString(avatarThumbnail)).append("\n");
    sb.append("    firstName: ").append(toIndentedString(firstName)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastName: ").append(toIndentedString(lastName)).append("\n");
    sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
    sb.append("    organizations: ").append(toIndentedString(organizations)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    roles: ").append(toIndentedString(roles)).append("\n");
    sb.append("    since: ").append(toIndentedString(since)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("    website: ").append(toIndentedString(website)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

